package de.hdm_stuttgart.mi.sd1.task1;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

import static de.hdm_stuttgart.mi.sd1.task1.D_Clump.getClumpCount;
@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class D_ClumpTest extends ExaminationTestDefaults {

    @Test
    public void test_20_null() {
        Assert.assertEquals(0, getClumpCount(null));
    }
    @Test
    public void test_40_empty() {
        Assert.assertEquals(0, getClumpCount(new int[]{}));
    }

    @Test
    public void test_100_one() {
        Assert.assertEquals(0, getClumpCount(new int[]{-5}));
    }

    @Test
    public void test_200_two() {
        Assert.assertEquals(0, getClumpCount(new int[]{1, 0}));
        Assert.assertEquals(1, getClumpCount(new int[]{-2, -2}));
    }
    @Test
    public void test_300_three() {
        Assert.assertEquals(0, getClumpCount(new int[]{1, 2, 3}));
        Assert.assertEquals(1, getClumpCount(new int[]{1, 1, 3}));
        Assert.assertEquals(1, getClumpCount(new int[]{-7, 4, 4}));
        Assert.assertEquals(1, getClumpCount(new int[]{6, 6, 6}));
    }
    @Test
    public void test_400_four() {
        Assert.assertEquals(0, getClumpCount(new int[]{1, 2, -3, 50}));
        Assert.assertEquals(1, getClumpCount(new int[]{-3, -3, 0, 30}));
        Assert.assertEquals(1, getClumpCount(new int[]{-3, 7, 7, -70}));
        Assert.assertEquals(1, getClumpCount(new int[]{-3, 6, 0, 0}));
        Assert.assertEquals(1, getClumpCount(new int[]{4, 4, 4, 1}));
        Assert.assertEquals(1, getClumpCount(new int[]{1, 7, 7, 7}));
        Assert.assertEquals(1, getClumpCount(new int[]{1, 1, 1, 1}));

        Assert.assertEquals(2, getClumpCount(new int[]{1, 1, -5, -5}));
    }
    @Test
    public void test_500_five_six() {

        // five
        Assert.assertEquals(0, getClumpCount(new int[]{-6, -3, 0, 30, 1}));

        Assert.assertEquals(1, getClumpCount(new int[]{1, 1, 2, 3, 4}));
        Assert.assertEquals(1, getClumpCount(new int[]{1, 2, 2, 3, 4}));
        Assert.assertEquals(1, getClumpCount(new int[]{1, 2, 3, 3, 4}));
        Assert.assertEquals(1, getClumpCount(new int[]{1, 2, 3, 4, 4}));

        Assert.assertEquals(1, getClumpCount(new int[]{1, 1, 1, 3, 4}));
        Assert.assertEquals(1, getClumpCount(new int[]{0, 2, 2, 2, 4}));
        Assert.assertEquals(1, getClumpCount(new int[]{1, 2, 3, 3, 3}));

        Assert.assertEquals(1, getClumpCount(new int[]{1, 1, 1, 1, 4}));
        Assert.assertEquals(1, getClumpCount(new int[]{0, 2, 2, 2, 2}));
        Assert.assertEquals(1, getClumpCount(new int[]{4, 4, 4, 4, 4}));

        Assert.assertEquals(2, getClumpCount(new int[]{-3, -3, 5, 5, 10}));
        Assert.assertEquals(2, getClumpCount(new int[]{-3, 7, 7, 1, 1}));
        Assert.assertEquals(2, getClumpCount(new int[]{-3, -3, 0, 10, 10}));

        // Six
        Assert.assertEquals(3, getClumpCount(new int[]{0, 1, 1, 4, 7, 10, 10, 5, 9, 9, 9, 6}));
        Assert.assertEquals(3, getClumpCount(new int[]{1, 1, 4, 7, 10, 10, 5, 9, 9, 9, 8}));
        Assert.assertEquals(3, getClumpCount(new int[]{2, 1, 1, 4, 7, 10, 10, 5, 9, 9, 9}));
        Assert.assertEquals(3, getClumpCount(new int[]{1, 1, 1, 4, 7, 10, 10, 5, 9, 9, 9}));
        Assert.assertEquals(1, getClumpCount(new int[]{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1}));
        Assert.assertEquals(1, getClumpCount(new int[]{3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0}));
    }
}
