package de.hdm_stuttgart.mi.sd1.task1;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

import static de.hdm_stuttgart.mi.sd1.task1.B_Backup.createBackupFilename;

@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class B_BackupTest extends ExaminationTestDefaults {

    @Test
    @Marking(points = 5)
    public void test_100_noExtension() {
        Assert.assertEquals("starter_backup", createBackupFilename("starter", "_backup"));
        Assert.assertEquals("ab", createBackupFilename("a", "b"));
    }

    @Test
    @Marking(points = 5)
    public void test_200_singleExtension() {
        Assert.assertEquals("calc-b.ods", createBackupFilename("calc.ods", "-b"));
        Assert.assertEquals("backup.config", createBackupFilename(".config", "backup"));
    }

    @Test
    @Marking(points = 2)
    public void test_300_multipleExtensions() {
        Assert.assertEquals("file.b.c+backup.d", createBackupFilename("file.b.c.d", "+backup"));
    }
}
