package de.hdm_stuttgart.mi.sd1.task1;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import org.junit.Assert;
import org.junit.Test;

public class A_PaymentTest extends ExaminationTestDefaults {

    static final private double EPS = 1.E-13;
    @Test
    @Marking(points = 8)
    public void testFreeShippingPayment () {

        for (int orderSum = 5000; orderSum < 10000; orderSum++) {
            for (int day = 3; day < 100; day++) {
                test(orderSum / 100., orderSum / 100., day);
            }
            for (int day = 0; day <= 2; day++) {
                test(orderSum * 98 / 10000., orderSum / 100., day);
            }
        }
    }

    @Test
    @Marking(points = 8)
    public void testNonfreeShippingPayment () {

        for (int orderSum = 1; orderSum < 5000; orderSum++) {
            for (int day = 3; day < 100; day++) {
                test(orderSum / 100. + 6.50, orderSum / 100., day);
            }
            for (int day = 0; day <= 2; day++) {
                test(orderSum * 98 / 10000. + 6.50, orderSum / 100., day);
            }
        }
    }

    static private void test(final double expectedCosts, final double amount, int paymentDelay) {

        final String message = "An order worth of " + amount + "€ and payment at day " + paymentDelay +
                " results in total costs of " + expectedCosts + "€";

        Assert.assertEquals(
                message,
                expectedCosts,
                A_Payment.getBillingAmount(amount, paymentDelay),
                EPS);
    }
}
